package hpdos_rdma_offloaded.handler;

import java.net.InetSocketAddress;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Properties;
import java.util.Set;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

import com.ibm.darpc.DaRPCClientEndpoint;
import com.ibm.darpc.DaRPCClientGroup;
import com.ibm.darpc.DaRPCStream;

import hpdos_rdma_offloaded.lib.Follower;
import hpdos_rdma_offloaded.lib.Packet;
import hpdos_rdma_offloaded.rdma_protocol.Request;
import hpdos_rdma_offloaded.rdma_protocol.Response;
import hpdos_rdma_offloaded.rdma_protocol.RpcProtocol;

public class NetworkHandler {
    StorageHandler storageHandler;
    private ExecutorService executorService;
    public HashMap<String, DaRPCStream<Request, Response>> streams;
    // public static List<Follower> followers = new ArrayList<>();
    boolean isMaster;

    public NetworkHandler(){}

    public NetworkHandler(StorageHandler storageHandler, Properties properties){
        this.storageHandler = storageHandler;
        
        this.executorService = Executors.newFixedThreadPool(10);
        this.isMaster = Boolean.valueOf((String)properties.get("app.MASTER"));
    }
    
    public void connectToSals() throws Exception{
        // RpcProtocol rpcProtocol = new RpcProtocol();
        // DaRPCClientGroup<Request, Response> group = DaRPCClientGroup.createClientGroup(rpcProtocol, 100, 0, 16, 16); 
        // InetSocketAddress address = new InetSocketAddress("192.168.200.50", 1919);
        // DaRPCClientEndpoint<Request, Response> clientEp = group.createEndpoint();
        // clientEp.connect(address, 1000);
        // DaRPCStream<Request, Response> stream = clientEp.createStream();
        
        // if(!stream.isEmpty()){
        //     this.streams.put("192.168.200.50", stream);
        // }
    }

    public void connectToFollower(String uid , String ip) throws Exception {
        Thread.sleep(3000);
        System.out.println("Making rdma connection to follower.");
        Follower follower = new Follower();
        follower.setFollowerId(uid);
        follower.setIpAddress(ip);
        RpcProtocol rpcProtocol = new RpcProtocol();
        DaRPCClientGroup<Request, Response> group = DaRPCClientGroup.createClientGroup(rpcProtocol, 100, 0, 16, 16); 
        InetSocketAddress address = new InetSocketAddress(ip, 1921);
        DaRPCClientEndpoint<Request, Response> clientEp = group.createEndpoint();
        clientEp.connect(address, 1000);
        DaRPCStream<Request, Response> stream = clientEp.createStream();
        follower.setStream(stream);
        ReplicationHandler.followers.add(follower);
    }
    


    // Change the Futre to CompletableFuture to achieve correct asynchronousness
    public void create(Packet packet) throws InterruptedException, ExecutionException{
        System.out.println("Received create request for key/value: " + packet.getKey() + "/" + packet.getValue());
        Response response = new Response();
        Future<String> futureRocksDB = this.executorService.submit(()->{
            // Write code to write to rocksdb memtable here.
            // Change return type as required.
            return "";
        });

        if (this.isMaster) {
            System.out.println("Starting replication");
            Future<Response> futureReplication = this.executorService.submit(()->{
                Response replicationResponse = new Response();
                // Write code to replicate the data to other nics
                ReplicationHandler.replicateMetadata(packet);
                return replicationResponse;
            }); 
            response = futureReplication.get();     
            System.out.println("Replicating complete");
        }
        
        // Write the return type for local write
        futureRocksDB.get();

        // Write code to parse the responses here.
    }

    public void read(Packet packet){
        // Read the key, and check if it is avaible in memtable
        // if (//check for key) {
            
        // } else {
           // Read from SSD 
        // }
    }

    public void update(Packet packet) throws InterruptedException, ExecutionException{
        Future<String> futureRocksDB = this.executorService.submit(()->{
            // Write code to write to rocksdb memtable here.
            // Change return type as required.
            return "";
        });
        if (isMaster) {
            Future<Response> futureReplication = this.executorService.submit(()->{
                Response response = new Response();
                // Write code to replicate the data to other nics
                return response;
            });
    
            Future<Boolean> futureInvalidation = this.executorService.submit(()->{
                sendInvalidationRequest(packet);
                return false;
            });
            Response response = futureReplication.get();
            futureInvalidation.get();
        }
        // Write the return type for local write
        futureRocksDB.get();
        
        
        // Write code to parse the responses here.
    }

    // To implement delete
    public void delete(Packet packet){

    }



    public void sendInvalidationRequest(Packet packet) throws InterruptedException, ExecutionException{
        Set<Callable<Response>> callables = new HashSet<>();
        for (DaRPCStream<Request, Response> stream: streams.values()) {
            callables.add(() -> {
                Request request = new Request();
                Response response = new Response();
                request.setOperationType(104);
                request.setKey("");
                request.setValue("");
                response = stream.request(request, response, false).get();
                return response;
            });
        }

        List<Future<Response>> futures = this.executorService.invokeAll(callables);

        for (Future<Response> future: futures) {
            Response response;
            response = future.get(); 
            
        }
    }

}
