package hpdos_rdma_offloaded.service;

import java.io.IOException;
import java.util.concurrent.ExecutionException;

import com.ibm.darpc.DaRPCServerEndpoint;
import com.ibm.darpc.DaRPCServerEvent;
import com.ibm.darpc.DaRPCService;

import hpdos_rdma_offloaded.handler.NetworkHandler;
import hpdos_rdma_offloaded.lib.Packet;
import hpdos_rdma_offloaded.rdma_protocol.Request;
import hpdos_rdma_offloaded.rdma_protocol.Response;
import hpdos_rdma_offloaded.rdma_protocol.RpcProtocol;

public class MetadataServerService extends RpcProtocol implements DaRPCService<Request, Response>{
    NetworkHandler networkHandler;

    public MetadataServerService(NetworkHandler networkHandler){
        this.networkHandler = networkHandler;
    }

    @Override
    public void processServerEvent(DaRPCServerEvent<Request, Response> event) throws IOException {
        // TODO Auto-generated method stub
        Request request = event.getReceiveMessage();
        Response response = event.getSendMessage();
        if (request.getOperationType() == 100) {
            // Write code for create
            Packet packet =  new Packet(request.getOperationType(), request.getKey(), request.getValue());
            try {
                this.networkHandler.create(packet);
                response.setAct(0);
                response.setKey(null);
                response.setValue(null);
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        } 
        else if(request.getOperationType() == 101) {
            // Write code for read
        }   
        else if(request.getOperationType() == 102){
            // Write code for update
        }
        else if(request.getOperationType() == 103){
            // Write code for delete
        }
        event.triggerResponse();
    }

    @Override
    public void open(DaRPCServerEndpoint<Request, Response> rpcClientEndpoint) {
        // TODO Auto-generated method stub
        System.out.println("Received new connection...");
    }

    @Override
    public void close(DaRPCServerEndpoint<Request, Response> rpcClientEndpoint) {
        // TODO Auto-generated method stub
        
    }
    
}
